﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using System.Text;

namespace TargetSearchVariations
{
  class Program
  {
    static void Main(string[] args)
    {
      Boolean includeStopWordsInSearch = false;
      String includeStopWordsInSearchString = "stopWords_";
      Boolean excludeNonWordsFromSearch = false;
      String excludeNonWordsFromSearchString = "_nonWords_";
      Boolean excludeIndexEntriesFromSearch = false;
      String excludeIndexEntriesFromSearchString = "_indexEntries_";
      Boolean preMergeSearchDatabaseFile = false;
      String preMergeSearchDatabaseFileString = "_preMerge_";
      Boolean chunkLargeSearchDatabaseFiles = false;
      String chunkLargeSearchDatabaseFilesString = "_chunk_";
      Boolean enablePartialWordSearching = false;
      String enablePartialWordSearchingString = "_partialWord_";

      String baseTargetName = "target_";

      XDocument targetFile = XDocument.Load(args[0]);

      Char[] binaryValueText = { '0', '0', '0', '0', '0', '0' };

      for (int i = 0; i < 64; i++)
      {
        String binaryValueString = Convert.ToString(i, 2);
        for (int j = binaryValueString.Length; j < 6; j++)
        {
          binaryValueString = "0" + binaryValueString;
        }
        binaryValueText = binaryValueString.ToCharArray();

        includeStopWordsInSearch = binaryValueText[0].Equals('1');
        excludeNonWordsFromSearch = binaryValueText[1].Equals('1');
        excludeIndexEntriesFromSearch = binaryValueText[2].Equals('1');
        preMergeSearchDatabaseFile = binaryValueText[3].Equals('1');
        chunkLargeSearchDatabaseFiles = binaryValueText[4].Equals('1');
        enablePartialWordSearching = binaryValueText[5].Equals('1');

        String newTargetName = baseTargetName +
          includeStopWordsInSearchString + 
          includeStopWordsInSearch.ToString().Substring(0, 1) +
          excludeNonWordsFromSearchString + 
          excludeNonWordsFromSearch.ToString().Substring(0, 1) +
          excludeIndexEntriesFromSearchString + 
          excludeIndexEntriesFromSearch.ToString().Substring(0, 1) +
          preMergeSearchDatabaseFileString + 
          preMergeSearchDatabaseFile.ToString().Substring(0, 1) +
          chunkLargeSearchDatabaseFilesString + 
          chunkLargeSearchDatabaseFiles.ToString().Substring(0, 1) +
          enablePartialWordSearchingString +
          enablePartialWordSearching.ToString().Substring(0, 1);

        targetFile.Root.SetAttributeValue("IncludeStopWords",
          includeStopWordsInSearch.ToString());
        targetFile.Root.SetAttributeValue("ExcludeNonWords",
          excludeNonWordsFromSearch.ToString());
        targetFile.Root.SetAttributeValue("ExcludeIndexEntriesFromSearch",
          excludeIndexEntriesFromSearch.ToString());
        targetFile.Root.SetAttributeValue("PreMergeSearchDatabase",
          preMergeSearchDatabaseFile.ToString());
        targetFile.Root.SetAttributeValue("ChunkSearchDatabaseIncludeStopWords",
          chunkLargeSearchDatabaseFiles.ToString());
        targetFile.Root.SetAttributeValue("PartialWordSearch",
          enablePartialWordSearching.ToString());

        targetFile.Save("C:\\TargetVariations\\" + newTargetName + ".fltar");
        Console.Out.WriteLine("Created: " + newTargetName);
      }
    }
  }
}
